/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ̃Tv́A}ʂɂ}igăAj[Vs܂B
// ̎ԂƂɁAzu}iړȂAC̕\Ԃ؂ւ邱Ƃ
// Aj[V̂悤ɌĂ܂B
//
// Copyright @ 2010 RootPro Co.,Ltd.
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

using RootPro.RootProCAD;
using RootPro.RootProCAD.Geometry;


namespace RCAddInRocketAnimationCS
{
    public partial class Form1 : Form
    {
        // uRootPro CADvAvP[V
        RootPro.RootProCAD.Application app;

        int currentAnimationIndex;

        string rpcdFilePath; // }ʃt@CpX
        bool fileExist;

        // Ce[u
        LayerTable layerTable;

        // JEg_Ep̃C
        Layer countdownTextLayer;
        // ˑ̃C
        Layer launchingPadLayer;
        // Pbg̃C
        Layer rocket0Layer;
        Layer[] rocketLayer = new Layer[2];
        // ñC
        Layer earthLayer;

        int countdownSecond = 4;@// JEg_E̎
        int risingSecond = 16;    // Pbg㏸


        // Aj[Vp̐}`
        TextShape countdownTextShape;
        DrawComponentShape[] rocketComponentShape = new DrawComponentShape[2];


        public Form1(RootPro.RootProCAD.Application app)
        {
            InitializeComponent();

            this.app = app;
        }

        /// <summary>
        /// tH[̃[h̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Load(object sender, EventArgs e)
        {
            // \[XɖߍłTvp̐}ʂ
            // }ChLgɃt@CƂĕۑB
            // iAj[VɎg}iȂǂ܂܂ꂽt@CŁÃt@CJĎg߁j

            // Tvt@C
            string temporaryPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            rpcdFilePath = temporaryPath + @"\_RootProCADAddInSampleAnimationParts.rpcd";
            fileExist = File.Exists(rpcdFilePath);
            // tH_ɃTvt@CȂꍇ
            if (fileExist == false)
            {
                // \[Xɖߍ񂾃Tvt@CoĎw肵pXɕۑ
                SaveAnimationPartsFile(rpcdFilePath);
            }

            // Tvt@CJ
            Document doc = app.Documents.Open(rpcdFilePath);

        }

        /// <summary>
        /// tH[Ƃ̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            // tH[JƂAt@CȂꍇ́A}ʂāAt@C폜
            if (fileExist == false)
            {
                Document doc = app.ActiveDocument;
                if (doc.FullName == rpcdFilePath)
                {
                    doc.Close();
                    File.Delete(rpcdFilePath);
                }
            }
        }

        /// <summary>
        /// \[Xɖߍ񂾃Tvt@CoĎw肵pXɕۑ
        /// </summary>
        /// <param name="saveFilePath">ۑt@C̃tpX</param>
        private void SaveAnimationPartsFile(string saveFilePath)
        {
            // ݎsĂAssembly擾
            System.Reflection.Assembly asm = this.GetType().Assembly;
            //string[] sss = asm.GetManifestResourceNames();// AZûׂẴ\[X̖OԂB
            System.IO.Stream s = asm.GetManifestResourceStream(asm.GetName().Name + ".Resources.animationparts.rpcd");

            BinaryReader read = new BinaryReader(s);
            FileStream fs = new FileStream(saveFilePath, FileMode.Create);
            BinaryWriter write = new BinaryWriter(fs);

            // Xg[ǂݏoăt@Cɏ
            byte[] bt = new byte[s.Length];
            s.Read(bt, 0, bt.Length);
            write.Write(bt);

            // N[Y
            s.Close();
            read.Close();
            write.Close();
            fs.Close();
        }


        /// <summary>
        /// X^[g{^NbNƂ̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click(object sender, EventArgs e)
        {
            //^C}[Ă鎞͎~߂ďI
            if (this.timer1.Enabled == true)
            {
                this.timer1.Enabled = false;
                button1.Text = "Start";
                return;
            }


            Document doc = app.ActiveDocument;
            Drawing drawing = doc.CurrentDrawing;

            // Ce[u̎擾
            layerTable = doc.LayerTable;
            // [gC̎擾
            Layer rootLayer = layerTable.RootLayer;
            // qC̃CRNV擾
            LayerCollection layerCollection = rootLayer.ChildLayers;

            // JEg_Ep̃C擾
            countdownTextLayer = layerCollection["Countdown"];

            // ˑ̃C擾
            launchingPadLayer = layerCollection["LaunchingPad"];
            launchingPadLayer.State = ShapeState.Visible;// \

            // Pbg̃C(Rocket0)擾
            rocket0Layer = layerCollection["Rocket0"];
            // JgCC(Rocket0)ɂ
            layerTable.CurrentLayer = rocket0Layer;

            // Pbg̃C(Rocket1, Rocket2)擾
            rocketLayer[0] = layerCollection["Rocket1"];
            rocketLayer[1] = layerCollection["Rocket2"];

            // ñC擾
            earthLayer = layerCollection["Earth"];
            earthLayer.State = ShapeState.NotVisible;// \

            // ShapeRNV擾
            ShapeCollection shapeCollection = drawing.Shapes;

            // Aj[VɎg}`ɂꍇ͍폜
            if (countdownTextShape != null)
            {
                shapeCollection.Remove(countdownTextShape);
                countdownTextShape = null;
            }

            // Pbgɂꍇ͍폜
            for (int i = 0; i < 2; i++)
            {
                if (rocketComponentShape[i] != null)
                {
                    shapeCollection.Remove(rocketComponentShape[i]);
                    rocketComponentShape[i] = null;
                }
            }

            // Pbg̍}i(Rocket1, Rocket2)}ʂɔzu
            MasterDrawComponentCollection drawComponentCollection = doc.MasterDrawComponents;
            MasterDrawComponent[] rocketDrawComponent = new MasterDrawComponent[2];
            for (int i = 0; i < 2; i++)
            {
                int rocketNo = i + 1;
                string componentName = "Rocket" + rocketNo.ToString();
                rocketDrawComponent[i] = drawComponentCollection[componentName];
                Point2d point1 = app.Geometry.CreatePoint(430, 300);
                double scaleX = 1.0;
                double scaleY = 1.0;
                double locateAngle = 0.0;
                rocketComponentShape[i] = drawing.Shapes.AddDrawComponent(rocketDrawComponent[i], point1, scaleX, scaleY, locateAngle, true);
            }


            //^C}[͓
            currentAnimationIndex = 0;
            this.timer1.Enabled = true;
            button1.Text = "Stop";
        }

        /// <summary>
        /// timer1TickCxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void timer1_Tick_1(object sender, EventArgs e)
        {
            ChangeAnimationSheet();
        }

        /// <summary>
        /// \̐؂ւ
        /// </summary>
        private void ChangeAnimationSheet()
        {
            Document doc = app.ActiveDocument;
            Drawing drawing = doc.CurrentDrawing;

            currentAnimationIndex++;

            // JEg_E
            if (currentAnimationIndex <= countdownSecond)
            {
                // 1b
                if (currentAnimationIndex == 1)
                {
                    // JEg_Ep̃CJg
                    layerTable.CurrentLayer = countdownTextLayer;

                    // ̍쐬
                    Point2d point1 = app.Geometry.CreatePoint(880, 450);
                    countdownTextShape = drawing.Shapes.AddText("3", point1, 0.0);
                }
                else
                {
                    // ̕ύX
                    int countValue = 4 - currentAnimationIndex;
                    countdownTextShape.Text = countValue.ToString();
                }

            }
            // Pbg->㏸->n
            else
            {
                int currentLayerIndex = (currentAnimationIndex - ((countdownSecond + 1) % 2)) % 2;// ŏ0ɂȂ悤
                double offsetHigth = 100.0;

                // JgC؂ւ
                layerTable.CurrentLayer = rocketLayer[currentLayerIndex];

                int rocketIndex = currentLayerIndex;
                int nextRocketIndex = rocketIndex + 1;
                if (nextRocketIndex > 1)
                    nextRocketIndex = 0;

                // Pbg->㏸
                if (currentAnimationIndex <= risingSecond)
                {
                    Point2d point1 = rocketComponentShape[rocketIndex].Point;
                    Point2d point2 = app.Geometry.CreatePoint(point1.X, point1.Y + offsetHigth);
                    rocketComponentShape[nextRocketIndex].Point = point2;
                }
                // n
                else
                {
                    if (currentAnimationIndex == risingSecond + 1)
                    {
                        launchingPadLayer.State = ShapeState.NotVisible;// ˑ͔\
                        earthLayer.State = ShapeState.Visible;// n\
                        layerTable.CurrentLayer = earthLayer;
                    }

                    // n̒SW(1700, 1700)
                    // N̔a800, 15x(360/24)ړ
                    int positionIndex = (currentAnimationIndex - (risingSecond + 1)) % 24;

                    double rotationAngle = Math.PI / 12.0 * positionIndex;
                    double x = 1700.0 - (800.0 * Math.Cos(rotationAngle));
                    double y = 1700.0 + (800.0 * Math.Sin(rotationAngle));

                    Point2d point1 = app.Geometry.CreatePoint(x, y);

                    rocketComponentShape[nextRocketIndex].Point = point1;
                    rocketComponentShape[nextRocketIndex].Angle = 360.0 - (15.0 * positionIndex);

                }
            }
        }

        /// <summary>
        /// Close {^NbNƂ̏
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }

  
  

    }
}